importScripts('doT.js');// no allowed request se://resouces/js/doT.js in WebWorker(chrome bugs)

String.prototype.shorting = function(len, omiss){
  omiss = omiss || ' ... ';
  if(this.length > len){
    return (this.substr(0,len/2) + omiss + this.substr(this.length-len/2)).toString();
  }else{
    return this.toString();
  }
}

function htmlEncode(str){
  var s = "";
  if(str.length==0)
    return "";

  s = str.replace(/&/g, "&amp;");
  s = s.replace(/</g, "&lt;");
  s = s.replace(/>/g, "&gt;");
  s = s.replace(/    /g, "&nbsp;");
  s = s.replace(/\'/g, "'");
  s = s.replace(/\"/g, "&quot;");
  s = s.replace(/\n/g, "<br>");
  return s;
}

function prefix_zero(num){
  return ('0' + num.toString()).substr(num.toString().length==1?0:1);
}
function joins(sortby, searchtext, tmplSiteHeader, tmplHistoryItem, items){
  var htmls = '',
  tmplSiteHeaderFn = doT.template(tmplSiteHeader),
  tmplHistoryItemFn = doT.template(tmplHistoryItem);


  if(sortby == 'site'){

    var prevItem;
    items.forEach(function(item){
      if(/^file:\/\/\//.test(item.url)){
        item.host = item.url.replace(/^file:\/\/\//,'');
      }
      item.host = item.host.shorting(50);
      item.title = htmlEncode(item.title);
      item.url = htmlEncode(item.url);
      item.imgurl = item.url.replace(/(\')/g, '\\$1');

      if(!prevItem || item.host != prevItem.host){
        htmls += tmplSiteHeaderFn(item);
      }
      var date = new Date(item.time*1000);
      item.strTime = prefix_zero(date.getHours()) + ':' + prefix_zero(date.getMinutes());
      if(searchtext){
        item.strTime = prefix_zero(date.getMonth() + 1) + '月' + prefix_zero(date.getDate()) + '日 ' + item.strTime;
      }
      htmls += tmplHistoryItemFn(item);
      prevItem = item;
    });
  }else{
    
    items.forEach(function(item){
      if(/^file:\/\/\//.test(item.url)){
        item.host = item.url.replace(/^file:\/\/\//,'');
      }
      item.host = item.host.shorting(50);
      item.title = htmlEncode(item.title);
      item.url = htmlEncode(item.url);
      item.imgurl = item.url.replace(/(\')/g, '\\$1');

      var date = new Date(item.time*1000);
      item.strTime = prefix_zero(date.getHours()) + ':' + prefix_zero(date.getMinutes());
      if(searchtext){
        item.strTime = prefix_zero(date.getMonth() + 1) + '月' + prefix_zero(date.getDate()) + '日 ' + item.strTime;
      }
      htmls += tmplHistoryItemFn(item);
    });
  }
  return htmls;
}

onmessage = function(ev){
  var htmls = joins(ev.data.sortby, ev.data.searchtext, ev.data.tmplSiteHeader, ev.data.tmplHistoryItem, ev.data.items);
  postMessage(htmls);
};
